/*

This file is part of jHaushalt.

jHaushalt is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

jHaushalt is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with jHaushalt; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(C)opyright 2002-2004 Dr. Lars H. Hahn

*/

package haushalt.gui.generischerdialog;

import haushalt.daten.Kategorie;

import java.awt.FlowLayout;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;

/**
 * @author Dr. Lars H. Hahn
 * @version 2.0/2004.08.22
 */

abstract public class AbstractGDPane extends JPanel {

  protected Object wert;
  
  protected AbstractGDPane(String text) {
    setBorder(BorderFactory.createTitledBorder(text));
    setLayout(new FlowLayout(FlowLayout.LEFT));
  }

  public Object getWert() {
    refreshWert();
    return wert;
  }

  abstract protected void refreshWert();

  public void refreshRegisterUndKategorien(Kategorie[] kategorien, String[] register) {
    // wenn eine GD eine Register oder Kategorieauswahl verwendet, muss diese
    // Methode berladen werden.
  }

  abstract protected JComponent getZentraleKomponente();
  
  abstract public void laden(DataInputStream in) throws IOException;
  
  abstract public void speichern(DataOutputStream out) throws IOException;

}